package cn.superdesk.uniorder.dao.entity.base;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class UnifiedOrderGoodsExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public UnifiedOrderGoodsExample() {
        oredCriteria = new ArrayList<>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    /**
    unified_order_goods
     *
     * Thu Jul 01 11:17:48 CST 2021
     */
    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andOrderSnIsNull() {
            addCriterion("order_sn is null");
            return (Criteria) this;
        }

        public Criteria andOrderSnIsNotNull() {
            addCriterion("order_sn is not null");
            return (Criteria) this;
        }

        public Criteria andOrderSnEqualTo(String value) {
            addCriterion("order_sn =", value, "orderSn");
            return (Criteria) this;
        }

        public Criteria andOrderSnNotEqualTo(String value) {
            addCriterion("order_sn <>", value, "orderSn");
            return (Criteria) this;
        }

        public Criteria andOrderSnGreaterThan(String value) {
            addCriterion("order_sn >", value, "orderSn");
            return (Criteria) this;
        }

        public Criteria andOrderSnGreaterThanOrEqualTo(String value) {
            addCriterion("order_sn >=", value, "orderSn");
            return (Criteria) this;
        }

        public Criteria andOrderSnLessThan(String value) {
            addCriterion("order_sn <", value, "orderSn");
            return (Criteria) this;
        }

        public Criteria andOrderSnLessThanOrEqualTo(String value) {
            addCriterion("order_sn <=", value, "orderSn");
            return (Criteria) this;
        }

        public Criteria andOrderSnLike(String value) {
            addCriterion("order_sn like", value, "orderSn");
            return (Criteria) this;
        }

        public Criteria andOrderSnNotLike(String value) {
            addCriterion("order_sn not like", value, "orderSn");
            return (Criteria) this;
        }

        public Criteria andOrderSnIn(List<String> values) {
            addCriterion("order_sn in", values, "orderSn");
            return (Criteria) this;
        }

        public Criteria andOrderSnNotIn(List<String> values) {
            addCriterion("order_sn not in", values, "orderSn");
            return (Criteria) this;
        }

        public Criteria andOrderSnBetween(String value1, String value2) {
            addCriterion("order_sn between", value1, value2, "orderSn");
            return (Criteria) this;
        }

        public Criteria andOrderSnNotBetween(String value1, String value2) {
            addCriterion("order_sn not between", value1, value2, "orderSn");
            return (Criteria) this;
        }

        public Criteria andGoodsNameIsNull() {
            addCriterion("goods_name is null");
            return (Criteria) this;
        }

        public Criteria andGoodsNameIsNotNull() {
            addCriterion("goods_name is not null");
            return (Criteria) this;
        }

        public Criteria andGoodsNameEqualTo(String value) {
            addCriterion("goods_name =", value, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameNotEqualTo(String value) {
            addCriterion("goods_name <>", value, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameGreaterThan(String value) {
            addCriterion("goods_name >", value, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameGreaterThanOrEqualTo(String value) {
            addCriterion("goods_name >=", value, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameLessThan(String value) {
            addCriterion("goods_name <", value, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameLessThanOrEqualTo(String value) {
            addCriterion("goods_name <=", value, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameLike(String value) {
            addCriterion("goods_name like", value, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameNotLike(String value) {
            addCriterion("goods_name not like", value, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameIn(List<String> values) {
            addCriterion("goods_name in", values, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameNotIn(List<String> values) {
            addCriterion("goods_name not in", values, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameBetween(String value1, String value2) {
            addCriterion("goods_name between", value1, value2, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameNotBetween(String value1, String value2) {
            addCriterion("goods_name not between", value1, value2, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsAliasIsNull() {
            addCriterion("goods_alias is null");
            return (Criteria) this;
        }

        public Criteria andGoodsAliasIsNotNull() {
            addCriterion("goods_alias is not null");
            return (Criteria) this;
        }

        public Criteria andGoodsAliasEqualTo(String value) {
            addCriterion("goods_alias =", value, "goodsAlias");
            return (Criteria) this;
        }

        public Criteria andGoodsAliasNotEqualTo(String value) {
            addCriterion("goods_alias <>", value, "goodsAlias");
            return (Criteria) this;
        }

        public Criteria andGoodsAliasGreaterThan(String value) {
            addCriterion("goods_alias >", value, "goodsAlias");
            return (Criteria) this;
        }

        public Criteria andGoodsAliasGreaterThanOrEqualTo(String value) {
            addCriterion("goods_alias >=", value, "goodsAlias");
            return (Criteria) this;
        }

        public Criteria andGoodsAliasLessThan(String value) {
            addCriterion("goods_alias <", value, "goodsAlias");
            return (Criteria) this;
        }

        public Criteria andGoodsAliasLessThanOrEqualTo(String value) {
            addCriterion("goods_alias <=", value, "goodsAlias");
            return (Criteria) this;
        }

        public Criteria andGoodsAliasLike(String value) {
            addCriterion("goods_alias like", value, "goodsAlias");
            return (Criteria) this;
        }

        public Criteria andGoodsAliasNotLike(String value) {
            addCriterion("goods_alias not like", value, "goodsAlias");
            return (Criteria) this;
        }

        public Criteria andGoodsAliasIn(List<String> values) {
            addCriterion("goods_alias in", values, "goodsAlias");
            return (Criteria) this;
        }

        public Criteria andGoodsAliasNotIn(List<String> values) {
            addCriterion("goods_alias not in", values, "goodsAlias");
            return (Criteria) this;
        }

        public Criteria andGoodsAliasBetween(String value1, String value2) {
            addCriterion("goods_alias between", value1, value2, "goodsAlias");
            return (Criteria) this;
        }

        public Criteria andGoodsAliasNotBetween(String value1, String value2) {
            addCriterion("goods_alias not between", value1, value2, "goodsAlias");
            return (Criteria) this;
        }

        public Criteria andGoodsIdIsNull() {
            addCriterion("goods_id is null");
            return (Criteria) this;
        }

        public Criteria andGoodsIdIsNotNull() {
            addCriterion("goods_id is not null");
            return (Criteria) this;
        }

        public Criteria andGoodsIdEqualTo(Long value) {
            addCriterion("goods_id =", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdNotEqualTo(Long value) {
            addCriterion("goods_id <>", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdGreaterThan(Long value) {
            addCriterion("goods_id >", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdGreaterThanOrEqualTo(Long value) {
            addCriterion("goods_id >=", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdLessThan(Long value) {
            addCriterion("goods_id <", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdLessThanOrEqualTo(Long value) {
            addCriterion("goods_id <=", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdIn(List<Long> values) {
            addCriterion("goods_id in", values, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdNotIn(List<Long> values) {
            addCriterion("goods_id not in", values, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdBetween(Long value1, Long value2) {
            addCriterion("goods_id between", value1, value2, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdNotBetween(Long value1, Long value2) {
            addCriterion("goods_id not between", value1, value2, "goodsId");
            return (Criteria) this;
        }

        public Criteria andOutSnapshotOrderGoodsIdIsNull() {
            addCriterion("out_snapshot_order_goods_id is null");
            return (Criteria) this;
        }

        public Criteria andOutSnapshotOrderGoodsIdIsNotNull() {
            addCriterion("out_snapshot_order_goods_id is not null");
            return (Criteria) this;
        }

        public Criteria andOutSnapshotOrderGoodsIdEqualTo(Long value) {
            addCriterion("out_snapshot_order_goods_id =", value, "outSnapshotOrderGoodsId");
            return (Criteria) this;
        }

        public Criteria andOutSnapshotOrderGoodsIdNotEqualTo(Long value) {
            addCriterion("out_snapshot_order_goods_id <>", value, "outSnapshotOrderGoodsId");
            return (Criteria) this;
        }

        public Criteria andOutSnapshotOrderGoodsIdGreaterThan(Long value) {
            addCriterion("out_snapshot_order_goods_id >", value, "outSnapshotOrderGoodsId");
            return (Criteria) this;
        }

        public Criteria andOutSnapshotOrderGoodsIdGreaterThanOrEqualTo(Long value) {
            addCriterion("out_snapshot_order_goods_id >=", value, "outSnapshotOrderGoodsId");
            return (Criteria) this;
        }

        public Criteria andOutSnapshotOrderGoodsIdLessThan(Long value) {
            addCriterion("out_snapshot_order_goods_id <", value, "outSnapshotOrderGoodsId");
            return (Criteria) this;
        }

        public Criteria andOutSnapshotOrderGoodsIdLessThanOrEqualTo(Long value) {
            addCriterion("out_snapshot_order_goods_id <=", value, "outSnapshotOrderGoodsId");
            return (Criteria) this;
        }

        public Criteria andOutSnapshotOrderGoodsIdIn(List<Long> values) {
            addCriterion("out_snapshot_order_goods_id in", values, "outSnapshotOrderGoodsId");
            return (Criteria) this;
        }

        public Criteria andOutSnapshotOrderGoodsIdNotIn(List<Long> values) {
            addCriterion("out_snapshot_order_goods_id not in", values, "outSnapshotOrderGoodsId");
            return (Criteria) this;
        }

        public Criteria andOutSnapshotOrderGoodsIdBetween(Long value1, Long value2) {
            addCriterion("out_snapshot_order_goods_id between", value1, value2, "outSnapshotOrderGoodsId");
            return (Criteria) this;
        }

        public Criteria andOutSnapshotOrderGoodsIdNotBetween(Long value1, Long value2) {
            addCriterion("out_snapshot_order_goods_id not between", value1, value2, "outSnapshotOrderGoodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeIsNull() {
            addCriterion("goods_type is null");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeIsNotNull() {
            addCriterion("goods_type is not null");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeEqualTo(Integer value) {
            addCriterion("goods_type =", value, "goodsType");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeNotEqualTo(Integer value) {
            addCriterion("goods_type <>", value, "goodsType");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeGreaterThan(Integer value) {
            addCriterion("goods_type >", value, "goodsType");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("goods_type >=", value, "goodsType");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeLessThan(Integer value) {
            addCriterion("goods_type <", value, "goodsType");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeLessThanOrEqualTo(Integer value) {
            addCriterion("goods_type <=", value, "goodsType");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeIn(List<Integer> values) {
            addCriterion("goods_type in", values, "goodsType");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeNotIn(List<Integer> values) {
            addCriterion("goods_type not in", values, "goodsType");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeBetween(Integer value1, Integer value2) {
            addCriterion("goods_type between", value1, value2, "goodsType");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("goods_type not between", value1, value2, "goodsType");
            return (Criteria) this;
        }

        public Criteria andQuantityIsNull() {
            addCriterion("quantity is null");
            return (Criteria) this;
        }

        public Criteria andQuantityIsNotNull() {
            addCriterion("quantity is not null");
            return (Criteria) this;
        }

        public Criteria andQuantityEqualTo(Integer value) {
            addCriterion("quantity =", value, "quantity");
            return (Criteria) this;
        }

        public Criteria andQuantityNotEqualTo(Integer value) {
            addCriterion("quantity <>", value, "quantity");
            return (Criteria) this;
        }

        public Criteria andQuantityGreaterThan(Integer value) {
            addCriterion("quantity >", value, "quantity");
            return (Criteria) this;
        }

        public Criteria andQuantityGreaterThanOrEqualTo(Integer value) {
            addCriterion("quantity >=", value, "quantity");
            return (Criteria) this;
        }

        public Criteria andQuantityLessThan(Integer value) {
            addCriterion("quantity <", value, "quantity");
            return (Criteria) this;
        }

        public Criteria andQuantityLessThanOrEqualTo(Integer value) {
            addCriterion("quantity <=", value, "quantity");
            return (Criteria) this;
        }

        public Criteria andQuantityIn(List<Integer> values) {
            addCriterion("quantity in", values, "quantity");
            return (Criteria) this;
        }

        public Criteria andQuantityNotIn(List<Integer> values) {
            addCriterion("quantity not in", values, "quantity");
            return (Criteria) this;
        }

        public Criteria andQuantityBetween(Integer value1, Integer value2) {
            addCriterion("quantity between", value1, value2, "quantity");
            return (Criteria) this;
        }

        public Criteria andQuantityNotBetween(Integer value1, Integer value2) {
            addCriterion("quantity not between", value1, value2, "quantity");
            return (Criteria) this;
        }

        public Criteria andUnitIsNull() {
            addCriterion("unit is null");
            return (Criteria) this;
        }

        public Criteria andUnitIsNotNull() {
            addCriterion("unit is not null");
            return (Criteria) this;
        }

        public Criteria andUnitEqualTo(String value) {
            addCriterion("unit =", value, "unit");
            return (Criteria) this;
        }

        public Criteria andUnitNotEqualTo(String value) {
            addCriterion("unit <>", value, "unit");
            return (Criteria) this;
        }

        public Criteria andUnitGreaterThan(String value) {
            addCriterion("unit >", value, "unit");
            return (Criteria) this;
        }

        public Criteria andUnitGreaterThanOrEqualTo(String value) {
            addCriterion("unit >=", value, "unit");
            return (Criteria) this;
        }

        public Criteria andUnitLessThan(String value) {
            addCriterion("unit <", value, "unit");
            return (Criteria) this;
        }

        public Criteria andUnitLessThanOrEqualTo(String value) {
            addCriterion("unit <=", value, "unit");
            return (Criteria) this;
        }

        public Criteria andUnitLike(String value) {
            addCriterion("unit like", value, "unit");
            return (Criteria) this;
        }

        public Criteria andUnitNotLike(String value) {
            addCriterion("unit not like", value, "unit");
            return (Criteria) this;
        }

        public Criteria andUnitIn(List<String> values) {
            addCriterion("unit in", values, "unit");
            return (Criteria) this;
        }

        public Criteria andUnitNotIn(List<String> values) {
            addCriterion("unit not in", values, "unit");
            return (Criteria) this;
        }

        public Criteria andUnitBetween(String value1, String value2) {
            addCriterion("unit between", value1, value2, "unit");
            return (Criteria) this;
        }

        public Criteria andUnitNotBetween(String value1, String value2) {
            addCriterion("unit not between", value1, value2, "unit");
            return (Criteria) this;
        }

        public Criteria andPriceIsNull() {
            addCriterion("price is null");
            return (Criteria) this;
        }

        public Criteria andPriceIsNotNull() {
            addCriterion("price is not null");
            return (Criteria) this;
        }

        public Criteria andPriceEqualTo(BigDecimal value) {
            addCriterion("price =", value, "price");
            return (Criteria) this;
        }

        public Criteria andPriceNotEqualTo(BigDecimal value) {
            addCriterion("price <>", value, "price");
            return (Criteria) this;
        }

        public Criteria andPriceGreaterThan(BigDecimal value) {
            addCriterion("price >", value, "price");
            return (Criteria) this;
        }

        public Criteria andPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("price >=", value, "price");
            return (Criteria) this;
        }

        public Criteria andPriceLessThan(BigDecimal value) {
            addCriterion("price <", value, "price");
            return (Criteria) this;
        }

        public Criteria andPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("price <=", value, "price");
            return (Criteria) this;
        }

        public Criteria andPriceIn(List<BigDecimal> values) {
            addCriterion("price in", values, "price");
            return (Criteria) this;
        }

        public Criteria andPriceNotIn(List<BigDecimal> values) {
            addCriterion("price not in", values, "price");
            return (Criteria) this;
        }

        public Criteria andPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("price between", value1, value2, "price");
            return (Criteria) this;
        }

        public Criteria andPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("price not between", value1, value2, "price");
            return (Criteria) this;
        }

        public Criteria andCostPriceIsNull() {
            addCriterion("cost_price is null");
            return (Criteria) this;
        }

        public Criteria andCostPriceIsNotNull() {
            addCriterion("cost_price is not null");
            return (Criteria) this;
        }

        public Criteria andCostPriceEqualTo(BigDecimal value) {
            addCriterion("cost_price =", value, "costPrice");
            return (Criteria) this;
        }

        public Criteria andCostPriceNotEqualTo(BigDecimal value) {
            addCriterion("cost_price <>", value, "costPrice");
            return (Criteria) this;
        }

        public Criteria andCostPriceGreaterThan(BigDecimal value) {
            addCriterion("cost_price >", value, "costPrice");
            return (Criteria) this;
        }

        public Criteria andCostPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("cost_price >=", value, "costPrice");
            return (Criteria) this;
        }

        public Criteria andCostPriceLessThan(BigDecimal value) {
            addCriterion("cost_price <", value, "costPrice");
            return (Criteria) this;
        }

        public Criteria andCostPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("cost_price <=", value, "costPrice");
            return (Criteria) this;
        }

        public Criteria andCostPriceIn(List<BigDecimal> values) {
            addCriterion("cost_price in", values, "costPrice");
            return (Criteria) this;
        }

        public Criteria andCostPriceNotIn(List<BigDecimal> values) {
            addCriterion("cost_price not in", values, "costPrice");
            return (Criteria) this;
        }

        public Criteria andCostPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("cost_price between", value1, value2, "costPrice");
            return (Criteria) this;
        }

        public Criteria andCostPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("cost_price not between", value1, value2, "costPrice");
            return (Criteria) this;
        }

        public Criteria andFiscalCodeIsNull() {
            addCriterion("fiscal_code is null");
            return (Criteria) this;
        }

        public Criteria andFiscalCodeIsNotNull() {
            addCriterion("fiscal_code is not null");
            return (Criteria) this;
        }

        public Criteria andFiscalCodeEqualTo(String value) {
            addCriterion("fiscal_code =", value, "fiscalCode");
            return (Criteria) this;
        }

        public Criteria andFiscalCodeNotEqualTo(String value) {
            addCriterion("fiscal_code <>", value, "fiscalCode");
            return (Criteria) this;
        }

        public Criteria andFiscalCodeGreaterThan(String value) {
            addCriterion("fiscal_code >", value, "fiscalCode");
            return (Criteria) this;
        }

        public Criteria andFiscalCodeGreaterThanOrEqualTo(String value) {
            addCriterion("fiscal_code >=", value, "fiscalCode");
            return (Criteria) this;
        }

        public Criteria andFiscalCodeLessThan(String value) {
            addCriterion("fiscal_code <", value, "fiscalCode");
            return (Criteria) this;
        }

        public Criteria andFiscalCodeLessThanOrEqualTo(String value) {
            addCriterion("fiscal_code <=", value, "fiscalCode");
            return (Criteria) this;
        }

        public Criteria andFiscalCodeLike(String value) {
            addCriterion("fiscal_code like", value, "fiscalCode");
            return (Criteria) this;
        }

        public Criteria andFiscalCodeNotLike(String value) {
            addCriterion("fiscal_code not like", value, "fiscalCode");
            return (Criteria) this;
        }

        public Criteria andFiscalCodeIn(List<String> values) {
            addCriterion("fiscal_code in", values, "fiscalCode");
            return (Criteria) this;
        }

        public Criteria andFiscalCodeNotIn(List<String> values) {
            addCriterion("fiscal_code not in", values, "fiscalCode");
            return (Criteria) this;
        }

        public Criteria andFiscalCodeBetween(String value1, String value2) {
            addCriterion("fiscal_code between", value1, value2, "fiscalCode");
            return (Criteria) this;
        }

        public Criteria andFiscalCodeNotBetween(String value1, String value2) {
            addCriterion("fiscal_code not between", value1, value2, "fiscalCode");
            return (Criteria) this;
        }

        public Criteria andTaxCodeIsNull() {
            addCriterion("tax_code is null");
            return (Criteria) this;
        }

        public Criteria andTaxCodeIsNotNull() {
            addCriterion("tax_code is not null");
            return (Criteria) this;
        }

        public Criteria andTaxCodeEqualTo(String value) {
            addCriterion("tax_code =", value, "taxCode");
            return (Criteria) this;
        }

        public Criteria andTaxCodeNotEqualTo(String value) {
            addCriterion("tax_code <>", value, "taxCode");
            return (Criteria) this;
        }

        public Criteria andTaxCodeGreaterThan(String value) {
            addCriterion("tax_code >", value, "taxCode");
            return (Criteria) this;
        }

        public Criteria andTaxCodeGreaterThanOrEqualTo(String value) {
            addCriterion("tax_code >=", value, "taxCode");
            return (Criteria) this;
        }

        public Criteria andTaxCodeLessThan(String value) {
            addCriterion("tax_code <", value, "taxCode");
            return (Criteria) this;
        }

        public Criteria andTaxCodeLessThanOrEqualTo(String value) {
            addCriterion("tax_code <=", value, "taxCode");
            return (Criteria) this;
        }

        public Criteria andTaxCodeLike(String value) {
            addCriterion("tax_code like", value, "taxCode");
            return (Criteria) this;
        }

        public Criteria andTaxCodeNotLike(String value) {
            addCriterion("tax_code not like", value, "taxCode");
            return (Criteria) this;
        }

        public Criteria andTaxCodeIn(List<String> values) {
            addCriterion("tax_code in", values, "taxCode");
            return (Criteria) this;
        }

        public Criteria andTaxCodeNotIn(List<String> values) {
            addCriterion("tax_code not in", values, "taxCode");
            return (Criteria) this;
        }

        public Criteria andTaxCodeBetween(String value1, String value2) {
            addCriterion("tax_code between", value1, value2, "taxCode");
            return (Criteria) this;
        }

        public Criteria andTaxCodeNotBetween(String value1, String value2) {
            addCriterion("tax_code not between", value1, value2, "taxCode");
            return (Criteria) this;
        }

        public Criteria andTaxRateIsNull() {
            addCriterion("tax_rate is null");
            return (Criteria) this;
        }

        public Criteria andTaxRateIsNotNull() {
            addCriterion("tax_rate is not null");
            return (Criteria) this;
        }

        public Criteria andTaxRateEqualTo(BigDecimal value) {
            addCriterion("tax_rate =", value, "taxRate");
            return (Criteria) this;
        }

        public Criteria andTaxRateNotEqualTo(BigDecimal value) {
            addCriterion("tax_rate <>", value, "taxRate");
            return (Criteria) this;
        }

        public Criteria andTaxRateGreaterThan(BigDecimal value) {
            addCriterion("tax_rate >", value, "taxRate");
            return (Criteria) this;
        }

        public Criteria andTaxRateGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("tax_rate >=", value, "taxRate");
            return (Criteria) this;
        }

        public Criteria andTaxRateLessThan(BigDecimal value) {
            addCriterion("tax_rate <", value, "taxRate");
            return (Criteria) this;
        }

        public Criteria andTaxRateLessThanOrEqualTo(BigDecimal value) {
            addCriterion("tax_rate <=", value, "taxRate");
            return (Criteria) this;
        }

        public Criteria andTaxRateIn(List<BigDecimal> values) {
            addCriterion("tax_rate in", values, "taxRate");
            return (Criteria) this;
        }

        public Criteria andTaxRateNotIn(List<BigDecimal> values) {
            addCriterion("tax_rate not in", values, "taxRate");
            return (Criteria) this;
        }

        public Criteria andTaxRateBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("tax_rate between", value1, value2, "taxRate");
            return (Criteria) this;
        }

        public Criteria andTaxRateNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("tax_rate not between", value1, value2, "taxRate");
            return (Criteria) this;
        }

        public Criteria andMerchTaxIdIsNull() {
            addCriterion("merch_tax_id is null");
            return (Criteria) this;
        }

        public Criteria andMerchTaxIdIsNotNull() {
            addCriterion("merch_tax_id is not null");
            return (Criteria) this;
        }

        public Criteria andMerchTaxIdEqualTo(Long value) {
            addCriterion("merch_tax_id =", value, "merchTaxId");
            return (Criteria) this;
        }

        public Criteria andMerchTaxIdNotEqualTo(Long value) {
            addCriterion("merch_tax_id <>", value, "merchTaxId");
            return (Criteria) this;
        }

        public Criteria andMerchTaxIdGreaterThan(Long value) {
            addCriterion("merch_tax_id >", value, "merchTaxId");
            return (Criteria) this;
        }

        public Criteria andMerchTaxIdGreaterThanOrEqualTo(Long value) {
            addCriterion("merch_tax_id >=", value, "merchTaxId");
            return (Criteria) this;
        }

        public Criteria andMerchTaxIdLessThan(Long value) {
            addCriterion("merch_tax_id <", value, "merchTaxId");
            return (Criteria) this;
        }

        public Criteria andMerchTaxIdLessThanOrEqualTo(Long value) {
            addCriterion("merch_tax_id <=", value, "merchTaxId");
            return (Criteria) this;
        }

        public Criteria andMerchTaxIdIn(List<Long> values) {
            addCriterion("merch_tax_id in", values, "merchTaxId");
            return (Criteria) this;
        }

        public Criteria andMerchTaxIdNotIn(List<Long> values) {
            addCriterion("merch_tax_id not in", values, "merchTaxId");
            return (Criteria) this;
        }

        public Criteria andMerchTaxIdBetween(Long value1, Long value2) {
            addCriterion("merch_tax_id between", value1, value2, "merchTaxId");
            return (Criteria) this;
        }

        public Criteria andMerchTaxIdNotBetween(Long value1, Long value2) {
            addCriterion("merch_tax_id not between", value1, value2, "merchTaxId");
            return (Criteria) this;
        }

        public Criteria andMerchTaxCodeIsNull() {
            addCriterion("merch_tax_code is null");
            return (Criteria) this;
        }

        public Criteria andMerchTaxCodeIsNotNull() {
            addCriterion("merch_tax_code is not null");
            return (Criteria) this;
        }

        public Criteria andMerchTaxCodeEqualTo(String value) {
            addCriterion("merch_tax_code =", value, "merchTaxCode");
            return (Criteria) this;
        }

        public Criteria andMerchTaxCodeNotEqualTo(String value) {
            addCriterion("merch_tax_code <>", value, "merchTaxCode");
            return (Criteria) this;
        }

        public Criteria andMerchTaxCodeGreaterThan(String value) {
            addCriterion("merch_tax_code >", value, "merchTaxCode");
            return (Criteria) this;
        }

        public Criteria andMerchTaxCodeGreaterThanOrEqualTo(String value) {
            addCriterion("merch_tax_code >=", value, "merchTaxCode");
            return (Criteria) this;
        }

        public Criteria andMerchTaxCodeLessThan(String value) {
            addCriterion("merch_tax_code <", value, "merchTaxCode");
            return (Criteria) this;
        }

        public Criteria andMerchTaxCodeLessThanOrEqualTo(String value) {
            addCriterion("merch_tax_code <=", value, "merchTaxCode");
            return (Criteria) this;
        }

        public Criteria andMerchTaxCodeLike(String value) {
            addCriterion("merch_tax_code like", value, "merchTaxCode");
            return (Criteria) this;
        }

        public Criteria andMerchTaxCodeNotLike(String value) {
            addCriterion("merch_tax_code not like", value, "merchTaxCode");
            return (Criteria) this;
        }

        public Criteria andMerchTaxCodeIn(List<String> values) {
            addCriterion("merch_tax_code in", values, "merchTaxCode");
            return (Criteria) this;
        }

        public Criteria andMerchTaxCodeNotIn(List<String> values) {
            addCriterion("merch_tax_code not in", values, "merchTaxCode");
            return (Criteria) this;
        }

        public Criteria andMerchTaxCodeBetween(String value1, String value2) {
            addCriterion("merch_tax_code between", value1, value2, "merchTaxCode");
            return (Criteria) this;
        }

        public Criteria andMerchTaxCodeNotBetween(String value1, String value2) {
            addCriterion("merch_tax_code not between", value1, value2, "merchTaxCode");
            return (Criteria) this;
        }

        public Criteria andMerchTaxRateIsNull() {
            addCriterion("merch_tax_rate is null");
            return (Criteria) this;
        }

        public Criteria andMerchTaxRateIsNotNull() {
            addCriterion("merch_tax_rate is not null");
            return (Criteria) this;
        }

        public Criteria andMerchTaxRateEqualTo(BigDecimal value) {
            addCriterion("merch_tax_rate =", value, "merchTaxRate");
            return (Criteria) this;
        }

        public Criteria andMerchTaxRateNotEqualTo(BigDecimal value) {
            addCriterion("merch_tax_rate <>", value, "merchTaxRate");
            return (Criteria) this;
        }

        public Criteria andMerchTaxRateGreaterThan(BigDecimal value) {
            addCriterion("merch_tax_rate >", value, "merchTaxRate");
            return (Criteria) this;
        }

        public Criteria andMerchTaxRateGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("merch_tax_rate >=", value, "merchTaxRate");
            return (Criteria) this;
        }

        public Criteria andMerchTaxRateLessThan(BigDecimal value) {
            addCriterion("merch_tax_rate <", value, "merchTaxRate");
            return (Criteria) this;
        }

        public Criteria andMerchTaxRateLessThanOrEqualTo(BigDecimal value) {
            addCriterion("merch_tax_rate <=", value, "merchTaxRate");
            return (Criteria) this;
        }

        public Criteria andMerchTaxRateIn(List<BigDecimal> values) {
            addCriterion("merch_tax_rate in", values, "merchTaxRate");
            return (Criteria) this;
        }

        public Criteria andMerchTaxRateNotIn(List<BigDecimal> values) {
            addCriterion("merch_tax_rate not in", values, "merchTaxRate");
            return (Criteria) this;
        }

        public Criteria andMerchTaxRateBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("merch_tax_rate between", value1, value2, "merchTaxRate");
            return (Criteria) this;
        }

        public Criteria andMerchTaxRateNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("merch_tax_rate not between", value1, value2, "merchTaxRate");
            return (Criteria) this;
        }

        public Criteria andOperationTaxIdIsNull() {
            addCriterion("operation_tax_id is null");
            return (Criteria) this;
        }

        public Criteria andOperationTaxIdIsNotNull() {
            addCriterion("operation_tax_id is not null");
            return (Criteria) this;
        }

        public Criteria andOperationTaxIdEqualTo(Long value) {
            addCriterion("operation_tax_id =", value, "operationTaxId");
            return (Criteria) this;
        }

        public Criteria andOperationTaxIdNotEqualTo(Long value) {
            addCriterion("operation_tax_id <>", value, "operationTaxId");
            return (Criteria) this;
        }

        public Criteria andOperationTaxIdGreaterThan(Long value) {
            addCriterion("operation_tax_id >", value, "operationTaxId");
            return (Criteria) this;
        }

        public Criteria andOperationTaxIdGreaterThanOrEqualTo(Long value) {
            addCriterion("operation_tax_id >=", value, "operationTaxId");
            return (Criteria) this;
        }

        public Criteria andOperationTaxIdLessThan(Long value) {
            addCriterion("operation_tax_id <", value, "operationTaxId");
            return (Criteria) this;
        }

        public Criteria andOperationTaxIdLessThanOrEqualTo(Long value) {
            addCriterion("operation_tax_id <=", value, "operationTaxId");
            return (Criteria) this;
        }

        public Criteria andOperationTaxIdIn(List<Long> values) {
            addCriterion("operation_tax_id in", values, "operationTaxId");
            return (Criteria) this;
        }

        public Criteria andOperationTaxIdNotIn(List<Long> values) {
            addCriterion("operation_tax_id not in", values, "operationTaxId");
            return (Criteria) this;
        }

        public Criteria andOperationTaxIdBetween(Long value1, Long value2) {
            addCriterion("operation_tax_id between", value1, value2, "operationTaxId");
            return (Criteria) this;
        }

        public Criteria andOperationTaxIdNotBetween(Long value1, Long value2) {
            addCriterion("operation_tax_id not between", value1, value2, "operationTaxId");
            return (Criteria) this;
        }

        public Criteria andOperationTaxCodeIsNull() {
            addCriterion("operation_tax_code is null");
            return (Criteria) this;
        }

        public Criteria andOperationTaxCodeIsNotNull() {
            addCriterion("operation_tax_code is not null");
            return (Criteria) this;
        }

        public Criteria andOperationTaxCodeEqualTo(String value) {
            addCriterion("operation_tax_code =", value, "operationTaxCode");
            return (Criteria) this;
        }

        public Criteria andOperationTaxCodeNotEqualTo(String value) {
            addCriterion("operation_tax_code <>", value, "operationTaxCode");
            return (Criteria) this;
        }

        public Criteria andOperationTaxCodeGreaterThan(String value) {
            addCriterion("operation_tax_code >", value, "operationTaxCode");
            return (Criteria) this;
        }

        public Criteria andOperationTaxCodeGreaterThanOrEqualTo(String value) {
            addCriterion("operation_tax_code >=", value, "operationTaxCode");
            return (Criteria) this;
        }

        public Criteria andOperationTaxCodeLessThan(String value) {
            addCriterion("operation_tax_code <", value, "operationTaxCode");
            return (Criteria) this;
        }

        public Criteria andOperationTaxCodeLessThanOrEqualTo(String value) {
            addCriterion("operation_tax_code <=", value, "operationTaxCode");
            return (Criteria) this;
        }

        public Criteria andOperationTaxCodeLike(String value) {
            addCriterion("operation_tax_code like", value, "operationTaxCode");
            return (Criteria) this;
        }

        public Criteria andOperationTaxCodeNotLike(String value) {
            addCriterion("operation_tax_code not like", value, "operationTaxCode");
            return (Criteria) this;
        }

        public Criteria andOperationTaxCodeIn(List<String> values) {
            addCriterion("operation_tax_code in", values, "operationTaxCode");
            return (Criteria) this;
        }

        public Criteria andOperationTaxCodeNotIn(List<String> values) {
            addCriterion("operation_tax_code not in", values, "operationTaxCode");
            return (Criteria) this;
        }

        public Criteria andOperationTaxCodeBetween(String value1, String value2) {
            addCriterion("operation_tax_code between", value1, value2, "operationTaxCode");
            return (Criteria) this;
        }

        public Criteria andOperationTaxCodeNotBetween(String value1, String value2) {
            addCriterion("operation_tax_code not between", value1, value2, "operationTaxCode");
            return (Criteria) this;
        }

        public Criteria andOperationTaxRateIsNull() {
            addCriterion("operation_tax_rate is null");
            return (Criteria) this;
        }

        public Criteria andOperationTaxRateIsNotNull() {
            addCriterion("operation_tax_rate is not null");
            return (Criteria) this;
        }

        public Criteria andOperationTaxRateEqualTo(BigDecimal value) {
            addCriterion("operation_tax_rate =", value, "operationTaxRate");
            return (Criteria) this;
        }

        public Criteria andOperationTaxRateNotEqualTo(BigDecimal value) {
            addCriterion("operation_tax_rate <>", value, "operationTaxRate");
            return (Criteria) this;
        }

        public Criteria andOperationTaxRateGreaterThan(BigDecimal value) {
            addCriterion("operation_tax_rate >", value, "operationTaxRate");
            return (Criteria) this;
        }

        public Criteria andOperationTaxRateGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("operation_tax_rate >=", value, "operationTaxRate");
            return (Criteria) this;
        }

        public Criteria andOperationTaxRateLessThan(BigDecimal value) {
            addCriterion("operation_tax_rate <", value, "operationTaxRate");
            return (Criteria) this;
        }

        public Criteria andOperationTaxRateLessThanOrEqualTo(BigDecimal value) {
            addCriterion("operation_tax_rate <=", value, "operationTaxRate");
            return (Criteria) this;
        }

        public Criteria andOperationTaxRateIn(List<BigDecimal> values) {
            addCriterion("operation_tax_rate in", values, "operationTaxRate");
            return (Criteria) this;
        }

        public Criteria andOperationTaxRateNotIn(List<BigDecimal> values) {
            addCriterion("operation_tax_rate not in", values, "operationTaxRate");
            return (Criteria) this;
        }

        public Criteria andOperationTaxRateBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("operation_tax_rate between", value1, value2, "operationTaxRate");
            return (Criteria) this;
        }

        public Criteria andOperationTaxRateNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("operation_tax_rate not between", value1, value2, "operationTaxRate");
            return (Criteria) this;
        }

        public Criteria andCateIdLv1IsNull() {
            addCriterion("cate_id_lv1 is null");
            return (Criteria) this;
        }

        public Criteria andCateIdLv1IsNotNull() {
            addCriterion("cate_id_lv1 is not null");
            return (Criteria) this;
        }

        public Criteria andCateIdLv1EqualTo(Long value) {
            addCriterion("cate_id_lv1 =", value, "cateIdLv1");
            return (Criteria) this;
        }

        public Criteria andCateIdLv1NotEqualTo(Long value) {
            addCriterion("cate_id_lv1 <>", value, "cateIdLv1");
            return (Criteria) this;
        }

        public Criteria andCateIdLv1GreaterThan(Long value) {
            addCriterion("cate_id_lv1 >", value, "cateIdLv1");
            return (Criteria) this;
        }

        public Criteria andCateIdLv1GreaterThanOrEqualTo(Long value) {
            addCriterion("cate_id_lv1 >=", value, "cateIdLv1");
            return (Criteria) this;
        }

        public Criteria andCateIdLv1LessThan(Long value) {
            addCriterion("cate_id_lv1 <", value, "cateIdLv1");
            return (Criteria) this;
        }

        public Criteria andCateIdLv1LessThanOrEqualTo(Long value) {
            addCriterion("cate_id_lv1 <=", value, "cateIdLv1");
            return (Criteria) this;
        }

        public Criteria andCateIdLv1In(List<Long> values) {
            addCriterion("cate_id_lv1 in", values, "cateIdLv1");
            return (Criteria) this;
        }

        public Criteria andCateIdLv1NotIn(List<Long> values) {
            addCriterion("cate_id_lv1 not in", values, "cateIdLv1");
            return (Criteria) this;
        }

        public Criteria andCateIdLv1Between(Long value1, Long value2) {
            addCriterion("cate_id_lv1 between", value1, value2, "cateIdLv1");
            return (Criteria) this;
        }

        public Criteria andCateIdLv1NotBetween(Long value1, Long value2) {
            addCriterion("cate_id_lv1 not between", value1, value2, "cateIdLv1");
            return (Criteria) this;
        }

        public Criteria andCateNameLv1IsNull() {
            addCriterion("cate_name_lv1 is null");
            return (Criteria) this;
        }

        public Criteria andCateNameLv1IsNotNull() {
            addCriterion("cate_name_lv1 is not null");
            return (Criteria) this;
        }

        public Criteria andCateNameLv1EqualTo(String value) {
            addCriterion("cate_name_lv1 =", value, "cateNameLv1");
            return (Criteria) this;
        }

        public Criteria andCateNameLv1NotEqualTo(String value) {
            addCriterion("cate_name_lv1 <>", value, "cateNameLv1");
            return (Criteria) this;
        }

        public Criteria andCateNameLv1GreaterThan(String value) {
            addCriterion("cate_name_lv1 >", value, "cateNameLv1");
            return (Criteria) this;
        }

        public Criteria andCateNameLv1GreaterThanOrEqualTo(String value) {
            addCriterion("cate_name_lv1 >=", value, "cateNameLv1");
            return (Criteria) this;
        }

        public Criteria andCateNameLv1LessThan(String value) {
            addCriterion("cate_name_lv1 <", value, "cateNameLv1");
            return (Criteria) this;
        }

        public Criteria andCateNameLv1LessThanOrEqualTo(String value) {
            addCriterion("cate_name_lv1 <=", value, "cateNameLv1");
            return (Criteria) this;
        }

        public Criteria andCateNameLv1Like(String value) {
            addCriterion("cate_name_lv1 like", value, "cateNameLv1");
            return (Criteria) this;
        }

        public Criteria andCateNameLv1NotLike(String value) {
            addCriterion("cate_name_lv1 not like", value, "cateNameLv1");
            return (Criteria) this;
        }

        public Criteria andCateNameLv1In(List<String> values) {
            addCriterion("cate_name_lv1 in", values, "cateNameLv1");
            return (Criteria) this;
        }

        public Criteria andCateNameLv1NotIn(List<String> values) {
            addCriterion("cate_name_lv1 not in", values, "cateNameLv1");
            return (Criteria) this;
        }

        public Criteria andCateNameLv1Between(String value1, String value2) {
            addCriterion("cate_name_lv1 between", value1, value2, "cateNameLv1");
            return (Criteria) this;
        }

        public Criteria andCateNameLv1NotBetween(String value1, String value2) {
            addCriterion("cate_name_lv1 not between", value1, value2, "cateNameLv1");
            return (Criteria) this;
        }

        public Criteria andCateIdLv2IsNull() {
            addCriterion("cate_id_lv2 is null");
            return (Criteria) this;
        }

        public Criteria andCateIdLv2IsNotNull() {
            addCriterion("cate_id_lv2 is not null");
            return (Criteria) this;
        }

        public Criteria andCateIdLv2EqualTo(Long value) {
            addCriterion("cate_id_lv2 =", value, "cateIdLv2");
            return (Criteria) this;
        }

        public Criteria andCateIdLv2NotEqualTo(Long value) {
            addCriterion("cate_id_lv2 <>", value, "cateIdLv2");
            return (Criteria) this;
        }

        public Criteria andCateIdLv2GreaterThan(Long value) {
            addCriterion("cate_id_lv2 >", value, "cateIdLv2");
            return (Criteria) this;
        }

        public Criteria andCateIdLv2GreaterThanOrEqualTo(Long value) {
            addCriterion("cate_id_lv2 >=", value, "cateIdLv2");
            return (Criteria) this;
        }

        public Criteria andCateIdLv2LessThan(Long value) {
            addCriterion("cate_id_lv2 <", value, "cateIdLv2");
            return (Criteria) this;
        }

        public Criteria andCateIdLv2LessThanOrEqualTo(Long value) {
            addCriterion("cate_id_lv2 <=", value, "cateIdLv2");
            return (Criteria) this;
        }

        public Criteria andCateIdLv2In(List<Long> values) {
            addCriterion("cate_id_lv2 in", values, "cateIdLv2");
            return (Criteria) this;
        }

        public Criteria andCateIdLv2NotIn(List<Long> values) {
            addCriterion("cate_id_lv2 not in", values, "cateIdLv2");
            return (Criteria) this;
        }

        public Criteria andCateIdLv2Between(Long value1, Long value2) {
            addCriterion("cate_id_lv2 between", value1, value2, "cateIdLv2");
            return (Criteria) this;
        }

        public Criteria andCateIdLv2NotBetween(Long value1, Long value2) {
            addCriterion("cate_id_lv2 not between", value1, value2, "cateIdLv2");
            return (Criteria) this;
        }

        public Criteria andCateNameLv2IsNull() {
            addCriterion("cate_name_lv2 is null");
            return (Criteria) this;
        }

        public Criteria andCateNameLv2IsNotNull() {
            addCriterion("cate_name_lv2 is not null");
            return (Criteria) this;
        }

        public Criteria andCateNameLv2EqualTo(String value) {
            addCriterion("cate_name_lv2 =", value, "cateNameLv2");
            return (Criteria) this;
        }

        public Criteria andCateNameLv2NotEqualTo(String value) {
            addCriterion("cate_name_lv2 <>", value, "cateNameLv2");
            return (Criteria) this;
        }

        public Criteria andCateNameLv2GreaterThan(String value) {
            addCriterion("cate_name_lv2 >", value, "cateNameLv2");
            return (Criteria) this;
        }

        public Criteria andCateNameLv2GreaterThanOrEqualTo(String value) {
            addCriterion("cate_name_lv2 >=", value, "cateNameLv2");
            return (Criteria) this;
        }

        public Criteria andCateNameLv2LessThan(String value) {
            addCriterion("cate_name_lv2 <", value, "cateNameLv2");
            return (Criteria) this;
        }

        public Criteria andCateNameLv2LessThanOrEqualTo(String value) {
            addCriterion("cate_name_lv2 <=", value, "cateNameLv2");
            return (Criteria) this;
        }

        public Criteria andCateNameLv2Like(String value) {
            addCriterion("cate_name_lv2 like", value, "cateNameLv2");
            return (Criteria) this;
        }

        public Criteria andCateNameLv2NotLike(String value) {
            addCriterion("cate_name_lv2 not like", value, "cateNameLv2");
            return (Criteria) this;
        }

        public Criteria andCateNameLv2In(List<String> values) {
            addCriterion("cate_name_lv2 in", values, "cateNameLv2");
            return (Criteria) this;
        }

        public Criteria andCateNameLv2NotIn(List<String> values) {
            addCriterion("cate_name_lv2 not in", values, "cateNameLv2");
            return (Criteria) this;
        }

        public Criteria andCateNameLv2Between(String value1, String value2) {
            addCriterion("cate_name_lv2 between", value1, value2, "cateNameLv2");
            return (Criteria) this;
        }

        public Criteria andCateNameLv2NotBetween(String value1, String value2) {
            addCriterion("cate_name_lv2 not between", value1, value2, "cateNameLv2");
            return (Criteria) this;
        }

        public Criteria andCateIdLv3IsNull() {
            addCriterion("cate_id_lv3 is null");
            return (Criteria) this;
        }

        public Criteria andCateIdLv3IsNotNull() {
            addCriterion("cate_id_lv3 is not null");
            return (Criteria) this;
        }

        public Criteria andCateIdLv3EqualTo(Long value) {
            addCriterion("cate_id_lv3 =", value, "cateIdLv3");
            return (Criteria) this;
        }

        public Criteria andCateIdLv3NotEqualTo(Long value) {
            addCriterion("cate_id_lv3 <>", value, "cateIdLv3");
            return (Criteria) this;
        }

        public Criteria andCateIdLv3GreaterThan(Long value) {
            addCriterion("cate_id_lv3 >", value, "cateIdLv3");
            return (Criteria) this;
        }

        public Criteria andCateIdLv3GreaterThanOrEqualTo(Long value) {
            addCriterion("cate_id_lv3 >=", value, "cateIdLv3");
            return (Criteria) this;
        }

        public Criteria andCateIdLv3LessThan(Long value) {
            addCriterion("cate_id_lv3 <", value, "cateIdLv3");
            return (Criteria) this;
        }

        public Criteria andCateIdLv3LessThanOrEqualTo(Long value) {
            addCriterion("cate_id_lv3 <=", value, "cateIdLv3");
            return (Criteria) this;
        }

        public Criteria andCateIdLv3In(List<Long> values) {
            addCriterion("cate_id_lv3 in", values, "cateIdLv3");
            return (Criteria) this;
        }

        public Criteria andCateIdLv3NotIn(List<Long> values) {
            addCriterion("cate_id_lv3 not in", values, "cateIdLv3");
            return (Criteria) this;
        }

        public Criteria andCateIdLv3Between(Long value1, Long value2) {
            addCriterion("cate_id_lv3 between", value1, value2, "cateIdLv3");
            return (Criteria) this;
        }

        public Criteria andCateIdLv3NotBetween(Long value1, Long value2) {
            addCriterion("cate_id_lv3 not between", value1, value2, "cateIdLv3");
            return (Criteria) this;
        }

        public Criteria andCateNameLv3IsNull() {
            addCriterion("cate_name_lv3 is null");
            return (Criteria) this;
        }

        public Criteria andCateNameLv3IsNotNull() {
            addCriterion("cate_name_lv3 is not null");
            return (Criteria) this;
        }

        public Criteria andCateNameLv3EqualTo(String value) {
            addCriterion("cate_name_lv3 =", value, "cateNameLv3");
            return (Criteria) this;
        }

        public Criteria andCateNameLv3NotEqualTo(String value) {
            addCriterion("cate_name_lv3 <>", value, "cateNameLv3");
            return (Criteria) this;
        }

        public Criteria andCateNameLv3GreaterThan(String value) {
            addCriterion("cate_name_lv3 >", value, "cateNameLv3");
            return (Criteria) this;
        }

        public Criteria andCateNameLv3GreaterThanOrEqualTo(String value) {
            addCriterion("cate_name_lv3 >=", value, "cateNameLv3");
            return (Criteria) this;
        }

        public Criteria andCateNameLv3LessThan(String value) {
            addCriterion("cate_name_lv3 <", value, "cateNameLv3");
            return (Criteria) this;
        }

        public Criteria andCateNameLv3LessThanOrEqualTo(String value) {
            addCriterion("cate_name_lv3 <=", value, "cateNameLv3");
            return (Criteria) this;
        }

        public Criteria andCateNameLv3Like(String value) {
            addCriterion("cate_name_lv3 like", value, "cateNameLv3");
            return (Criteria) this;
        }

        public Criteria andCateNameLv3NotLike(String value) {
            addCriterion("cate_name_lv3 not like", value, "cateNameLv3");
            return (Criteria) this;
        }

        public Criteria andCateNameLv3In(List<String> values) {
            addCriterion("cate_name_lv3 in", values, "cateNameLv3");
            return (Criteria) this;
        }

        public Criteria andCateNameLv3NotIn(List<String> values) {
            addCriterion("cate_name_lv3 not in", values, "cateNameLv3");
            return (Criteria) this;
        }

        public Criteria andCateNameLv3Between(String value1, String value2) {
            addCriterion("cate_name_lv3 between", value1, value2, "cateNameLv3");
            return (Criteria) this;
        }

        public Criteria andCateNameLv3NotBetween(String value1, String value2) {
            addCriterion("cate_name_lv3 not between", value1, value2, "cateNameLv3");
            return (Criteria) this;
        }

        public Criteria andSelfOptionIsNull() {
            addCriterion("self_option is null");
            return (Criteria) this;
        }

        public Criteria andSelfOptionIsNotNull() {
            addCriterion("self_option is not null");
            return (Criteria) this;
        }

        public Criteria andSelfOptionEqualTo(String value) {
            addCriterion("self_option =", value, "selfOption");
            return (Criteria) this;
        }

        public Criteria andSelfOptionNotEqualTo(String value) {
            addCriterion("self_option <>", value, "selfOption");
            return (Criteria) this;
        }

        public Criteria andSelfOptionGreaterThan(String value) {
            addCriterion("self_option >", value, "selfOption");
            return (Criteria) this;
        }

        public Criteria andSelfOptionGreaterThanOrEqualTo(String value) {
            addCriterion("self_option >=", value, "selfOption");
            return (Criteria) this;
        }

        public Criteria andSelfOptionLessThan(String value) {
            addCriterion("self_option <", value, "selfOption");
            return (Criteria) this;
        }

        public Criteria andSelfOptionLessThanOrEqualTo(String value) {
            addCriterion("self_option <=", value, "selfOption");
            return (Criteria) this;
        }

        public Criteria andSelfOptionLike(String value) {
            addCriterion("self_option like", value, "selfOption");
            return (Criteria) this;
        }

        public Criteria andSelfOptionNotLike(String value) {
            addCriterion("self_option not like", value, "selfOption");
            return (Criteria) this;
        }

        public Criteria andSelfOptionIn(List<String> values) {
            addCriterion("self_option in", values, "selfOption");
            return (Criteria) this;
        }

        public Criteria andSelfOptionNotIn(List<String> values) {
            addCriterion("self_option not in", values, "selfOption");
            return (Criteria) this;
        }

        public Criteria andSelfOptionBetween(String value1, String value2) {
            addCriterion("self_option between", value1, value2, "selfOption");
            return (Criteria) this;
        }

        public Criteria andSelfOptionNotBetween(String value1, String value2) {
            addCriterion("self_option not between", value1, value2, "selfOption");
            return (Criteria) this;
        }

        public Criteria andDirectionIsNull() {
            addCriterion("direction is null");
            return (Criteria) this;
        }

        public Criteria andDirectionIsNotNull() {
            addCriterion("direction is not null");
            return (Criteria) this;
        }

        public Criteria andDirectionEqualTo(Integer value) {
            addCriterion("direction =", value, "direction");
            return (Criteria) this;
        }

        public Criteria andDirectionNotEqualTo(Integer value) {
            addCriterion("direction <>", value, "direction");
            return (Criteria) this;
        }

        public Criteria andDirectionGreaterThan(Integer value) {
            addCriterion("direction >", value, "direction");
            return (Criteria) this;
        }

        public Criteria andDirectionGreaterThanOrEqualTo(Integer value) {
            addCriterion("direction >=", value, "direction");
            return (Criteria) this;
        }

        public Criteria andDirectionLessThan(Integer value) {
            addCriterion("direction <", value, "direction");
            return (Criteria) this;
        }

        public Criteria andDirectionLessThanOrEqualTo(Integer value) {
            addCriterion("direction <=", value, "direction");
            return (Criteria) this;
        }

        public Criteria andDirectionIn(List<Integer> values) {
            addCriterion("direction in", values, "direction");
            return (Criteria) this;
        }

        public Criteria andDirectionNotIn(List<Integer> values) {
            addCriterion("direction not in", values, "direction");
            return (Criteria) this;
        }

        public Criteria andDirectionBetween(Integer value1, Integer value2) {
            addCriterion("direction between", value1, value2, "direction");
            return (Criteria) this;
        }

        public Criteria andDirectionNotBetween(Integer value1, Integer value2) {
            addCriterion("direction not between", value1, value2, "direction");
            return (Criteria) this;
        }

        public Criteria andGoodsLockingCustomerIsNull() {
            addCriterion("goods_locking_customer is null");
            return (Criteria) this;
        }

        public Criteria andGoodsLockingCustomerIsNotNull() {
            addCriterion("goods_locking_customer is not null");
            return (Criteria) this;
        }

        public Criteria andGoodsLockingCustomerEqualTo(Integer value) {
            addCriterion("goods_locking_customer =", value, "goodsLockingCustomer");
            return (Criteria) this;
        }

        public Criteria andGoodsLockingCustomerNotEqualTo(Integer value) {
            addCriterion("goods_locking_customer <>", value, "goodsLockingCustomer");
            return (Criteria) this;
        }

        public Criteria andGoodsLockingCustomerGreaterThan(Integer value) {
            addCriterion("goods_locking_customer >", value, "goodsLockingCustomer");
            return (Criteria) this;
        }

        public Criteria andGoodsLockingCustomerGreaterThanOrEqualTo(Integer value) {
            addCriterion("goods_locking_customer >=", value, "goodsLockingCustomer");
            return (Criteria) this;
        }

        public Criteria andGoodsLockingCustomerLessThan(Integer value) {
            addCriterion("goods_locking_customer <", value, "goodsLockingCustomer");
            return (Criteria) this;
        }

        public Criteria andGoodsLockingCustomerLessThanOrEqualTo(Integer value) {
            addCriterion("goods_locking_customer <=", value, "goodsLockingCustomer");
            return (Criteria) this;
        }

        public Criteria andGoodsLockingCustomerIn(List<Integer> values) {
            addCriterion("goods_locking_customer in", values, "goodsLockingCustomer");
            return (Criteria) this;
        }

        public Criteria andGoodsLockingCustomerNotIn(List<Integer> values) {
            addCriterion("goods_locking_customer not in", values, "goodsLockingCustomer");
            return (Criteria) this;
        }

        public Criteria andGoodsLockingCustomerBetween(Integer value1, Integer value2) {
            addCriterion("goods_locking_customer between", value1, value2, "goodsLockingCustomer");
            return (Criteria) this;
        }

        public Criteria andGoodsLockingCustomerNotBetween(Integer value1, Integer value2) {
            addCriterion("goods_locking_customer not between", value1, value2, "goodsLockingCustomer");
            return (Criteria) this;
        }

        public Criteria andGoodsLockingSupplierIsNull() {
            addCriterion("goods_locking_supplier is null");
            return (Criteria) this;
        }

        public Criteria andGoodsLockingSupplierIsNotNull() {
            addCriterion("goods_locking_supplier is not null");
            return (Criteria) this;
        }

        public Criteria andGoodsLockingSupplierEqualTo(Integer value) {
            addCriterion("goods_locking_supplier =", value, "goodsLockingSupplier");
            return (Criteria) this;
        }

        public Criteria andGoodsLockingSupplierNotEqualTo(Integer value) {
            addCriterion("goods_locking_supplier <>", value, "goodsLockingSupplier");
            return (Criteria) this;
        }

        public Criteria andGoodsLockingSupplierGreaterThan(Integer value) {
            addCriterion("goods_locking_supplier >", value, "goodsLockingSupplier");
            return (Criteria) this;
        }

        public Criteria andGoodsLockingSupplierGreaterThanOrEqualTo(Integer value) {
            addCriterion("goods_locking_supplier >=", value, "goodsLockingSupplier");
            return (Criteria) this;
        }

        public Criteria andGoodsLockingSupplierLessThan(Integer value) {
            addCriterion("goods_locking_supplier <", value, "goodsLockingSupplier");
            return (Criteria) this;
        }

        public Criteria andGoodsLockingSupplierLessThanOrEqualTo(Integer value) {
            addCriterion("goods_locking_supplier <=", value, "goodsLockingSupplier");
            return (Criteria) this;
        }

        public Criteria andGoodsLockingSupplierIn(List<Integer> values) {
            addCriterion("goods_locking_supplier in", values, "goodsLockingSupplier");
            return (Criteria) this;
        }

        public Criteria andGoodsLockingSupplierNotIn(List<Integer> values) {
            addCriterion("goods_locking_supplier not in", values, "goodsLockingSupplier");
            return (Criteria) this;
        }

        public Criteria andGoodsLockingSupplierBetween(Integer value1, Integer value2) {
            addCriterion("goods_locking_supplier between", value1, value2, "goodsLockingSupplier");
            return (Criteria) this;
        }

        public Criteria andGoodsLockingSupplierNotBetween(Integer value1, Integer value2) {
            addCriterion("goods_locking_supplier not between", value1, value2, "goodsLockingSupplier");
            return (Criteria) this;
        }

        public Criteria andAccountingStateCustomerIsNull() {
            addCriterion("accounting_state_customer is null");
            return (Criteria) this;
        }

        public Criteria andAccountingStateCustomerIsNotNull() {
            addCriterion("accounting_state_customer is not null");
            return (Criteria) this;
        }

        public Criteria andAccountingStateCustomerEqualTo(Integer value) {
            addCriterion("accounting_state_customer =", value, "accountingStateCustomer");
            return (Criteria) this;
        }

        public Criteria andAccountingStateCustomerNotEqualTo(Integer value) {
            addCriterion("accounting_state_customer <>", value, "accountingStateCustomer");
            return (Criteria) this;
        }

        public Criteria andAccountingStateCustomerGreaterThan(Integer value) {
            addCriterion("accounting_state_customer >", value, "accountingStateCustomer");
            return (Criteria) this;
        }

        public Criteria andAccountingStateCustomerGreaterThanOrEqualTo(Integer value) {
            addCriterion("accounting_state_customer >=", value, "accountingStateCustomer");
            return (Criteria) this;
        }

        public Criteria andAccountingStateCustomerLessThan(Integer value) {
            addCriterion("accounting_state_customer <", value, "accountingStateCustomer");
            return (Criteria) this;
        }

        public Criteria andAccountingStateCustomerLessThanOrEqualTo(Integer value) {
            addCriterion("accounting_state_customer <=", value, "accountingStateCustomer");
            return (Criteria) this;
        }

        public Criteria andAccountingStateCustomerIn(List<Integer> values) {
            addCriterion("accounting_state_customer in", values, "accountingStateCustomer");
            return (Criteria) this;
        }

        public Criteria andAccountingStateCustomerNotIn(List<Integer> values) {
            addCriterion("accounting_state_customer not in", values, "accountingStateCustomer");
            return (Criteria) this;
        }

        public Criteria andAccountingStateCustomerBetween(Integer value1, Integer value2) {
            addCriterion("accounting_state_customer between", value1, value2, "accountingStateCustomer");
            return (Criteria) this;
        }

        public Criteria andAccountingStateCustomerNotBetween(Integer value1, Integer value2) {
            addCriterion("accounting_state_customer not between", value1, value2, "accountingStateCustomer");
            return (Criteria) this;
        }

        public Criteria andAccountingStateSupplierIsNull() {
            addCriterion("accounting_state_supplier is null");
            return (Criteria) this;
        }

        public Criteria andAccountingStateSupplierIsNotNull() {
            addCriterion("accounting_state_supplier is not null");
            return (Criteria) this;
        }

        public Criteria andAccountingStateSupplierEqualTo(Integer value) {
            addCriterion("accounting_state_supplier =", value, "accountingStateSupplier");
            return (Criteria) this;
        }

        public Criteria andAccountingStateSupplierNotEqualTo(Integer value) {
            addCriterion("accounting_state_supplier <>", value, "accountingStateSupplier");
            return (Criteria) this;
        }

        public Criteria andAccountingStateSupplierGreaterThan(Integer value) {
            addCriterion("accounting_state_supplier >", value, "accountingStateSupplier");
            return (Criteria) this;
        }

        public Criteria andAccountingStateSupplierGreaterThanOrEqualTo(Integer value) {
            addCriterion("accounting_state_supplier >=", value, "accountingStateSupplier");
            return (Criteria) this;
        }

        public Criteria andAccountingStateSupplierLessThan(Integer value) {
            addCriterion("accounting_state_supplier <", value, "accountingStateSupplier");
            return (Criteria) this;
        }

        public Criteria andAccountingStateSupplierLessThanOrEqualTo(Integer value) {
            addCriterion("accounting_state_supplier <=", value, "accountingStateSupplier");
            return (Criteria) this;
        }

        public Criteria andAccountingStateSupplierIn(List<Integer> values) {
            addCriterion("accounting_state_supplier in", values, "accountingStateSupplier");
            return (Criteria) this;
        }

        public Criteria andAccountingStateSupplierNotIn(List<Integer> values) {
            addCriterion("accounting_state_supplier not in", values, "accountingStateSupplier");
            return (Criteria) this;
        }

        public Criteria andAccountingStateSupplierBetween(Integer value1, Integer value2) {
            addCriterion("accounting_state_supplier between", value1, value2, "accountingStateSupplier");
            return (Criteria) this;
        }

        public Criteria andAccountingStateSupplierNotBetween(Integer value1, Integer value2) {
            addCriterion("accounting_state_supplier not between", value1, value2, "accountingStateSupplier");
            return (Criteria) this;
        }

        public Criteria andBackAccountStatusIsNull() {
            addCriterion("back_account_status is null");
            return (Criteria) this;
        }

        public Criteria andBackAccountStatusIsNotNull() {
            addCriterion("back_account_status is not null");
            return (Criteria) this;
        }

        public Criteria andBackAccountStatusEqualTo(Integer value) {
            addCriterion("back_account_status =", value, "backAccountStatus");
            return (Criteria) this;
        }

        public Criteria andBackAccountStatusNotEqualTo(Integer value) {
            addCriterion("back_account_status <>", value, "backAccountStatus");
            return (Criteria) this;
        }

        public Criteria andBackAccountStatusGreaterThan(Integer value) {
            addCriterion("back_account_status >", value, "backAccountStatus");
            return (Criteria) this;
        }

        public Criteria andBackAccountStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("back_account_status >=", value, "backAccountStatus");
            return (Criteria) this;
        }

        public Criteria andBackAccountStatusLessThan(Integer value) {
            addCriterion("back_account_status <", value, "backAccountStatus");
            return (Criteria) this;
        }

        public Criteria andBackAccountStatusLessThanOrEqualTo(Integer value) {
            addCriterion("back_account_status <=", value, "backAccountStatus");
            return (Criteria) this;
        }

        public Criteria andBackAccountStatusIn(List<Integer> values) {
            addCriterion("back_account_status in", values, "backAccountStatus");
            return (Criteria) this;
        }

        public Criteria andBackAccountStatusNotIn(List<Integer> values) {
            addCriterion("back_account_status not in", values, "backAccountStatus");
            return (Criteria) this;
        }

        public Criteria andBackAccountStatusBetween(Integer value1, Integer value2) {
            addCriterion("back_account_status between", value1, value2, "backAccountStatus");
            return (Criteria) this;
        }

        public Criteria andBackAccountStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("back_account_status not between", value1, value2, "backAccountStatus");
            return (Criteria) this;
        }

        public Criteria andRefundOrderSnIsNull() {
            addCriterion("refund_order_sn is null");
            return (Criteria) this;
        }

        public Criteria andRefundOrderSnIsNotNull() {
            addCriterion("refund_order_sn is not null");
            return (Criteria) this;
        }

        public Criteria andRefundOrderSnEqualTo(String value) {
            addCriterion("refund_order_sn =", value, "refundOrderSn");
            return (Criteria) this;
        }

        public Criteria andRefundOrderSnNotEqualTo(String value) {
            addCriterion("refund_order_sn <>", value, "refundOrderSn");
            return (Criteria) this;
        }

        public Criteria andRefundOrderSnGreaterThan(String value) {
            addCriterion("refund_order_sn >", value, "refundOrderSn");
            return (Criteria) this;
        }

        public Criteria andRefundOrderSnGreaterThanOrEqualTo(String value) {
            addCriterion("refund_order_sn >=", value, "refundOrderSn");
            return (Criteria) this;
        }

        public Criteria andRefundOrderSnLessThan(String value) {
            addCriterion("refund_order_sn <", value, "refundOrderSn");
            return (Criteria) this;
        }

        public Criteria andRefundOrderSnLessThanOrEqualTo(String value) {
            addCriterion("refund_order_sn <=", value, "refundOrderSn");
            return (Criteria) this;
        }

        public Criteria andRefundOrderSnLike(String value) {
            addCriterion("refund_order_sn like", value, "refundOrderSn");
            return (Criteria) this;
        }

        public Criteria andRefundOrderSnNotLike(String value) {
            addCriterion("refund_order_sn not like", value, "refundOrderSn");
            return (Criteria) this;
        }

        public Criteria andRefundOrderSnIn(List<String> values) {
            addCriterion("refund_order_sn in", values, "refundOrderSn");
            return (Criteria) this;
        }

        public Criteria andRefundOrderSnNotIn(List<String> values) {
            addCriterion("refund_order_sn not in", values, "refundOrderSn");
            return (Criteria) this;
        }

        public Criteria andRefundOrderSnBetween(String value1, String value2) {
            addCriterion("refund_order_sn between", value1, value2, "refundOrderSn");
            return (Criteria) this;
        }

        public Criteria andRefundOrderSnNotBetween(String value1, String value2) {
            addCriterion("refund_order_sn not between", value1, value2, "refundOrderSn");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdIsNull() {
            addCriterion("create_user_id is null");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdIsNotNull() {
            addCriterion("create_user_id is not null");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdEqualTo(Long value) {
            addCriterion("create_user_id =", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdNotEqualTo(Long value) {
            addCriterion("create_user_id <>", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdGreaterThan(Long value) {
            addCriterion("create_user_id >", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdGreaterThanOrEqualTo(Long value) {
            addCriterion("create_user_id >=", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdLessThan(Long value) {
            addCriterion("create_user_id <", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdLessThanOrEqualTo(Long value) {
            addCriterion("create_user_id <=", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdIn(List<Long> values) {
            addCriterion("create_user_id in", values, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdNotIn(List<Long> values) {
            addCriterion("create_user_id not in", values, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdBetween(Long value1, Long value2) {
            addCriterion("create_user_id between", value1, value2, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdNotBetween(Long value1, Long value2) {
            addCriterion("create_user_id not between", value1, value2, "createUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdIsNull() {
            addCriterion("update_user_id is null");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdIsNotNull() {
            addCriterion("update_user_id is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdEqualTo(Long value) {
            addCriterion("update_user_id =", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdNotEqualTo(Long value) {
            addCriterion("update_user_id <>", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdGreaterThan(Long value) {
            addCriterion("update_user_id >", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdGreaterThanOrEqualTo(Long value) {
            addCriterion("update_user_id >=", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdLessThan(Long value) {
            addCriterion("update_user_id <", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdLessThanOrEqualTo(Long value) {
            addCriterion("update_user_id <=", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdIn(List<Long> values) {
            addCriterion("update_user_id in", values, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdNotIn(List<Long> values) {
            addCriterion("update_user_id not in", values, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdBetween(Long value1, Long value2) {
            addCriterion("update_user_id between", value1, value2, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdNotBetween(Long value1, Long value2) {
            addCriterion("update_user_id not between", value1, value2, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andGoodsParamsIsNull() {
            addCriterion("goods_params is null");
            return (Criteria) this;
        }

        public Criteria andGoodsParamsIsNotNull() {
            addCriterion("goods_params is not null");
            return (Criteria) this;
        }

        public Criteria andGoodsParamsEqualTo(String value) {
            addCriterion("goods_params =", value, "goodsParams");
            return (Criteria) this;
        }

        public Criteria andGoodsParamsNotEqualTo(String value) {
            addCriterion("goods_params <>", value, "goodsParams");
            return (Criteria) this;
        }

        public Criteria andGoodsParamsGreaterThan(String value) {
            addCriterion("goods_params >", value, "goodsParams");
            return (Criteria) this;
        }

        public Criteria andGoodsParamsGreaterThanOrEqualTo(String value) {
            addCriterion("goods_params >=", value, "goodsParams");
            return (Criteria) this;
        }

        public Criteria andGoodsParamsLessThan(String value) {
            addCriterion("goods_params <", value, "goodsParams");
            return (Criteria) this;
        }

        public Criteria andGoodsParamsLessThanOrEqualTo(String value) {
            addCriterion("goods_params <=", value, "goodsParams");
            return (Criteria) this;
        }

        public Criteria andGoodsParamsLike(String value) {
            addCriterion("goods_params like", value, "goodsParams");
            return (Criteria) this;
        }

        public Criteria andGoodsParamsNotLike(String value) {
            addCriterion("goods_params not like", value, "goodsParams");
            return (Criteria) this;
        }

        public Criteria andGoodsParamsIn(List<String> values) {
            addCriterion("goods_params in", values, "goodsParams");
            return (Criteria) this;
        }

        public Criteria andGoodsParamsNotIn(List<String> values) {
            addCriterion("goods_params not in", values, "goodsParams");
            return (Criteria) this;
        }

        public Criteria andGoodsParamsBetween(String value1, String value2) {
            addCriterion("goods_params between", value1, value2, "goodsParams");
            return (Criteria) this;
        }

        public Criteria andGoodsParamsNotBetween(String value1, String value2) {
            addCriterion("goods_params not between", value1, value2, "goodsParams");
            return (Criteria) this;
        }
    }

    /**
    unified_order_goods
     *
     * do_not_delete_during_merge Thu Jul 01 11:17:48 CST 2021
     */
    public static class Criteria extends GeneratedCriteria {
        protected Criteria() {
            super();
        }
    }

    /**
    unified_order_goods
     *
     * Thu Jul 01 11:17:48 CST 2021
     */
    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}